<?php
/*
Plugin Name: Infographic Shortcodes
Plugin URI: http://www.coding-dude.com/wp/projects/infographic-charts-graphics-html-tags-library/infographic-sh…rdpress-plugin/
Description: This plugin allows easy usage of the <a href="http://codecanyon.net/item/infographic-charts-and-graphics-html-tags-library/6351274?ref=psddude">Infographic Charts and Graphics HTML Tags Library</a> through shortcodes. To insert infographic charts and graphs like piecharts, line charts, bar charts, etc. follow these steps: <ul><li>1) Download the <a href="http://codecanyon.net/item/infographic-charts-and-graphics-html-tags-library/6351274?ref=psddude">Infographic Library</a></li>, <li>2) From the downloaded package get the <em>src/infographic.min.js</em> file and upload it to your WordPress webserver</li>, <li>3) Go to the <a href="options-general.php?page=infographic">Infographic Shortcodes configuration page</a> and set the URL to point to the <em>infographic.min.js</em> file that you uploaded</li></ul>. After setting this plugin up you can use shortcodes for adding charts and graphs to your WordPress posts and pages. For each graph and chart there is also a wizard like window to configure each aspect.
Version: 1.0.0
Author: John Negoita
Author URI: http://www.coding-dude.com
*/

/**
 * Copyright (c) `date "+%Y"` Your Name. All rights reserved.
 *
 * Released under the GPL license
 * http://www.opensource.org/licenses/gpl-license.php
 *
 * This is an add-on for WordPress
 * http://wordpress.org/
 *
 * **********************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * **********************************************************************
 */

if (!defined('WP_CONTENT_URL'))
      define('WP_CONTENT_URL', get_option('siteurl').'/wp-content');
if (!defined('WP_CONTENT_DIR'))
      define('WP_CONTENT_DIR', ABSPATH.'wp-content');
if (!defined('WP_PLUGIN_URL'))
      define('WP_PLUGIN_URL', WP_CONTENT_URL.'/plugins');
if (!defined('WP_PLUGIN_DIR'))
      define('WP_PLUGIN_DIR', WP_CONTENT_DIR.'/plugins');

add_shortcode( 'infographic-piechart', 'infographic_shortcode_piechart' );
add_shortcode( 'infographic-shapebargraph', 'infographic_shortcode_shapebargraph' );
add_shortcode( 'infographic-shapegraph', 'infographic_shortcode_shapegraph' );
add_shortcode( 'infographic-linegraph', 'infographic_shortcode_linegraph' );
add_shortcode( 'infographic-bargraph', 'infographic_shortcode_bargraph' );
add_shortcode( 'ig-line', 'infographic_shortcode_line' );
add_shortcode( 'ig-point', 'infographic_shortcode_point' );
add_shortcode( 'ig-bargroup', 'infographic_shortcode_bargroup' );
add_shortcode( 'ig-bar', 'infographic_shortcode_bar' );
add_shortcode( 'ig-pieslice', 'infographic_shortcode_pieslice' );

add_shortcode('ig-cf','infographic_custom_fields');

// Hook into the 'wp_enqueue_scripts' action
add_action( 'wp_enqueue_scripts', 'infographic_scripts' );


//TinyMCE init
add_action('init', 'infographic_buttons');

// Add Shortcode
function attr_to_string($atts){
	$str = "";
	if (!empty($atts)){
		foreach ($atts as $key => $value) {

			$key = str_replace("_", "-", $key);
			$value = expand_custom_fields($value);
			$str .= " $key=\"$value\" ";
		}
	}
	return $str;
}
function infographic_custom_fields($atts, $text) {
	global $post;
	return get_post_meta($post->ID, $text, true);
}

function expand_custom_fields($value){

	if (strpos($value, "{") !== false) {
		$value = str_replace("{","[ig-cf]",$value);
		$value = str_replace("}","[/ig-cf]",$value);
		$value = do_shortcode($value);
	}
	return $value;
}
function infographic_shortcode_piechart( $atts, $content = null) {
	return '<infographic-piechart '.attr_to_string($atts).' ><infographic-data>'.do_shortcode( $content ).'</infographic-data></infographic-piechart>';
}
function infographic_shortcode_shapebargraph( $atts ) {

	// Code
	return '<infographic-shapebargraph '.attr_to_string($atts).' ></infographic-shapebargraph>';
}

function infographic_shortcode_shapegraph( $atts ) {
	// Code
	return '<infographic-shapegraph '.attr_to_string($atts).' ></infographic-shapegraph>';
}

function infographic_shortcode_linegraph( $atts, $content = null ) {
	return '<infographic-linegraph '.attr_to_string($atts).' ><infographic-data>'.do_shortcode( $content ).'<infographic-data></infographic-linegraph>';
}

function infographic_shortcode_bargraph( $atts, $content = null ) {
	return '<infographic-bargraph '.attr_to_string($atts).' ><infographic-data>'.do_shortcode( $content ).'<infographic-data></infographic-bargraph>';
}

function infographic_shortcode_pieslice( $atts ) {
	return '<infographic-pieslice value="'.expand_custom_fields($atts['value']).'" >'.$atts['label'].'</infographic-pieslice>';
}

function infographic_shortcode_line( $atts, $content = null ) {
	return '<infographic-line '.attr_to_string($atts).' >'.do_shortcode( $content ).'</infographic-line>';
}
function infographic_shortcode_point( $atts ) {
	return '<infographic-point value="'.expand_custom_fields($atts['value']).'" >'.$atts['label'].'</infographic-point>';
}

function infographic_shortcode_bargroup( $atts, $content = null ) {
	return '<infographic-bargroup '.attr_to_string($atts).' >'.do_shortcode( $content ).'</infographic-bargroup>';
}
function infographic_shortcode_bar( $atts ) {
	return '<infographic-bar value="'.expand_custom_fields($atts['value']).'" >'.$atts['label'].'</infographic-bar>';
}

// Register Script
function infographic_scripts() {
	$infographic_js_file = get_option('infographic_js_file');
	//wp_register_script( 'infographic-library', $infographic_js_file, false, '1.0.1', false );
	//wp_register_script( 'infographic-library', plugins_url('js/infographic.min.js',  __FILE__), false, '1.0.1', false );
	wp_enqueue_script( 'infographic-library', $infographic_js_file );
}



// TinyMCE buttons
function register_buttons( $buttons ) {
   array_push( $buttons, "|", "infographic-chart" );
   return $buttons;
}

function add_plugin( $plugin_array ) {
   $plugin_array['infographic.shortcodes'] = plugins_url('js/infographic.editor.ext.js',  __FILE__);
   // $plugin_array['infographic.shortcodes.backbone.forms'] = 'http://cdnjs.cloudflare.com/ajax/libs/backbone-forms/0.12.0/templates/backbone-forms.js';   
   $plugin_array['infographic.shortcodes.list.editor'] = plugins_url('js/editors/list.js',  __FILE__);
   $plugin_array['infographic.shortcodes.custom_editors'] = plugins_url('js/editors/editors.js',  __FILE__);
   return $plugin_array;
}

function infographic_buttons() {

   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') ) {
      return;
   }

   if ( get_user_option('rich_editing') == 'true' ) {
      add_filter( 'mce_external_plugins', 'add_plugin' );
      add_filter( 'mce_buttons', 'register_buttons' );

		// wp_enqueue_script('underscore', 'http://cdnjs.cloudflare.com/ajax/libs/underscore.js/1.5.2/underscore-min.js');
		// wp_enqueue_script('backbone', 'http://cdnjs.cloudflare.com/ajax/libs/backbone.js/1.1.0/backbone-min.js');
		//wp_enqueue_script('backbone-forms', 'http://cdnjs.cloudflare.com/ajax/libs/backbone-forms/0.12.0/backbone-forms.min.js');
		// wp_enqueue_script('backbone-forms', 'http://cdnjs.cloudflare.com/ajax/libs/backbone-forms/0.12.0/backbone-forms.min.js');
		// wp_enqueue_script('backbone-forms', 'http://cdnjs.cloudflare.com/ajax/libs/backbone-forms/0.12.0/templates/backbone-forms.js');

		wp_enqueue_script('jquery-ui-dialog');
		wp_enqueue_script('jquery-ui-autocomplete');
		wp_enqueue_style("wp-jquery-ui-dialog");
		wp_enqueue_style("wp-jquery-ui-autocomplete");
		wp_enqueue_script('underscore','http://cdnjs.cloudflare.com/ajax/libs/underscore.js/1.5.2/underscore-min.js');
		wp_enqueue_script('backbone','http://cdnjs.cloudflare.com/ajax/libs/backbone.js/1.1.0/backbone-min.js', array('underscore'));
		wp_enqueue_script('backbone-forms', 'http://cdnjs.cloudflare.com/ajax/libs/backbone-forms/0.12.0/templates/backbone-forms.js', array('backbone'));

		wp_register_style( 'infographic.shortcodes', plugins_url('css/editors.css', __FILE__) );
		wp_enqueue_style('infographic.shortcodes');
   }

}

function admin_init_infographic() {
  register_setting('infographic', 'infographic_js_file');
}

function admin_menu_infographic() {
  add_options_page('Infographic Shortcodes', 'Infographic Shortcodes', 'manage_options', 'infographic', 'options_page_infographic');
}

function options_page_infographic() {
  include(WP_PLUGIN_DIR.'/infographic-shortcodes/options.php');  
}

if (is_admin()) {
  add_action('admin_init', 'admin_init_infographic');
  add_action('admin_menu', 'admin_menu_infographic');
}

add_action('init', 'infographic_shortcodes_activate_au');
function infographic_shortcodes_activate_au()
{
    require_once ('lib/wp_auto_update.php');
    $infographic_shortcodes_plugin_current_version = '1.0.0';
    $infographic_shortcodes_plugin_remote_path = 'http://www.coding-dude.com/infographic-shortcodes/';
    $infographic_shortcodes_plugin_slug = plugin_basename(__FILE__);
    new wp_auto_update ($infographic_shortcodes_plugin_current_version, $infographic_shortcodes_plugin_remote_path, $infographic_shortcodes_plugin_slug);
}
?>