var InfographicClass = Backbone.Model.extend({
    schema: {
        graph:      { type: 'Select', options: ['piechart', 'shapebargraph', 'shapegraph']},
        id:       'Text',
        width:    'Number',
        height:   'Number'
    }
});

var piechartInfographicClass = InfographicClass.extend({
   schema: {
         value: 'Number',
         holeSize: 'Number'
   }
});

var shapebargraphInfographicClass = InfographicClass.extend({
   schema: {
         value: 'Number'
   }
});

function getGraphModel(m){ 
   var localClass = InfographicClass.extend({
      schema: jQuery.extend(InfographicClass.prototype.schema,
               {
                  "Required fields": {type: 'NestedModel', model: m},
                  "Extra attributes": 'TextArea'
               }
            )
   });

   return eval("new localClass()");
}

(function() {
   tinymce.create('tinymce.plugins.infographic.shortcodes', {
      init: function(ed, url) {



         ed.addButton('infographic-chart', {
            title: 'Infographic Chart',
            image: url + '/../img/chart.png',
            onclick: function() {


               var infographic = new shapebargraphInfographicClass();
               var m = getGraphModel(shapebargraphInfographicClass);
               

               var form = new Backbone.Form({
                   model: m
               }).render();


               form.on("change", function(_model,_name){ form.commit();});
               form.model.on("change:graph",
                  function(){
                     var sel = form.getValue().graph;
                     infographic = eval("new "+sel+"InfographicClass()");
                     m = getGraphModel(sel+"InfographicClass"); 
                     form = new Backbone.Form({
                               model: m
                           }).render(); 
                     jQuery('#myFancyDialog').html(form.el);
                  }
               );
               
               var dlg = jQuery("<div id='myFancyDialog' style='padding:10px;' title='Insert infographic' />")
                  .html(form.el)
                  .appendTo("body");

               dlg.dialog({
                  'dialogClass': 'wp-dialog',
                  'modal': true,
                  'autoOpen': false,
                  'closeOnEscape': true,
                  'buttons':

                  [{
                     'text': 'Insert',
                     'class': 'button-primary',
                     'click': function() {
                        form.commit();
                        var v = form.getValue();
                        ed.execCommand('mceInsertContent', false,
                           '[infographic-shapebargraph image="' + v.image + '" value="' + v.value + '" label="' + v.label + '" width="' + v.width + '" height="' + v.height + '"]'
                        );
                        jQuery(this).dialog('close');
                     }
                  },
                  {
                     'text': 'Close',
                     'class': '1button-primary',
                     'click': function() {
                        jQuery(this).dialog('close');
                     }
                  }]
               }).dialog('open');


               return;


               shapebarProperties(
                  function(frm) {
                     ed.execCommand('mceInsertContent', false,
                        '[infographic-shapebargraph image="' + frm.image.value + '" value="' + frm.value.value + '" label="' + frm.label.value + '" width="' + frm.width.value + '" height="' + frm.height.value + '"]'
                     );
                  }
               );
            }
         });
      },
      createControl: function(n, cm) {
         return null;
      },
      getInfo: function() {
         return {
            longname: "Recent Posts",
            author: 'Konstantinos Kouratoras',
            authorurl: 'http://www.kouratoras.gr',
            infourl: 'http://wp.smashingmagazine.com',
            version: "1.0"
         };
      }
   });
   tinymce.PluginManager.add('infographic.shortcodes', tinymce.plugins.infographic.shortcodes);
})();


function shapebarProperties(callback) {
   var fields = [{
      name: "image",
      label: "Image"
   }, {
      name: "value",
      label: "Value"
   }, {
      name: "label",
      label: "Label"
   }, {
      name: "width",
      label: "Width"
   }, {
      name: "height",
      label: "Height"
   }];
   var fieldsHTML = "";
   for (ob in fields) {
      fieldsHTML += "<label for='" + fields[ob].name + "'>" + fields[ob].label + "</label>:</br><input style='width:100%' name='" + fields[ob].name + "' type='text'><br/>";
   }

   var formId = "infographicShapebarForm" + Math.round(Math.random() * 100);
   var saveButtonId = "infographicShapebarFormSaveButton" + Math.round(Math.random() * 100);
   var closeButtonId = "infographicShapebarFormSaveButton" + Math.round(Math.random() * 100);
   var form =
      "<div style='position:fixed;z-index: 100;top:50%;left:50%;margin:-100px 0 0 -100px;width:200px;background-color:white;padding:20px;border:1px solid #ddd;'>" +
      "<form id='" + formId + "'>" +
      fieldsHTML +
      "<button id='" + saveButtonId + "'>Insert</button> <button id='" + closeButtonId + "'>Close</button>"
   "</form>" +
      "</div>";
   var el = document.createElement("p");
   el.innerHTML = form;
   document.body.appendChild(el);

   jQuery("#" + saveButtonId).click(
      function() {
         var frm = document.getElementById(formId);
         (callback)(frm);
         document.body.removeChild(el);
         return false;
      }
   );

   jQuery("#" + closeButtonId).click(
      function() {
         var frm = document.getElementById(formId);
         document.body.removeChild(el);
         return false;
      }
   );

   //jQuery(document).one("click",function(){document.body.removeChild(el)});
}